#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

#define ull unsigned long long
#define ll long long
using namespace std;

const int N = 1e6+1;

int main() {
    int t;
    cin >> t;
    while(t--) {
        ull a, b, k, m;
        cin >> a >> b >> k >> m;

        ull x, y;
        ull h, v;
        bool impossible = false;

        //x + y = k
        //(x+1) * (y+1) = m
        //xy + x + y + 1 = m
        //xy + k + 1 = m
        //xy = m - k - 1

        //x(k-x) = m - k - 1
        //kx - x^2 = m - k - 1
        //x^2 - kx + (m - k - 1) = 0
        //D = k^2 - 4(m - k - 1)
        //D = 5*5 - 4(12 - 5 - 1)
        //x1 = (k - D) / 2
        //x2 = (k + D) / 2

        ull n = m - k - 1;
        ll D = k*k - (4*n);
        // cout << "D: "<<D << endl;
        if (D < 0) {
            x = 0;
            y = 0;
            impossible = true;
        }
        else {
            ll x1 = (k - D) / 2;
            ll x2 = (k + D) / 2;

            ll y1 = k - x1;
            ll y2 = k - x2;

            if(x1 > 0 && y1 > 0 && min(x1, y1) < (min(a, b)) && max(x1, y1) < max(a, b)) {
                x = x1;
                y = y1;
            }
            else {
                x = x2;
                y = y2;
            }
        }


        if (a < b) {
            h = min(x, y);
            v = max(x, y);
        }
        else {
            h = max(x, y);
            v = min(x, y);
        }

        if (h >= a || v >= b || h < 0 || v < 0) {
            impossible = true;
        }

        if (impossible) {
            cout << -1 << endl;
        }
        else {
           cout << h << " " << v << endl;
        }

    }
}

/*
3
2 2 1 2
1 2 2 3
3 5 5 12
*/