#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <math.h>

#define ull unsigned long long
#define ll long long
using namespace std;

const int N = 1e6+1;
const double eps = 0.00000001;

int main() {
    int t;
    cin >> t;
    while(t--) {
        ull a, b, k, m;
        cin >> a >> b >> k >> m;

        ull x, y;
        ull h, v;
        bool impossible = false;
        bool v1 = false, v2 = false;

        //x + y = k
        //(x+1) * (y+1) = m
        //xy + x + y + 1 = m
        //xy + k + 1 = m
        //xy = m - k - 1

        //x(k-x) = m - k - 1
        //kx - x^2 = m - k - 1
        //x^2 - kx + (m - k - 1) = 0
        //D = k^2 - 4(m - k - 1)
        //D = 5*5 - 4(12 - 5 - 1)
        //x1 = (k - D) / 2
        //x2 = (k + D) / 2

        ull n = m - k - 1;
        ll D = k*k - (4*n);
        ll x1, y1, x2, y2;
        // cout << "D: "<<D << endl;
        if (D < 0 || (sqrt((double)D) - floor((double)D) > eps)) {
            x = 0;
            y = 0;
            impossible = true;
        }
        else {
            D = sqrt(D);
            x1 = (k - D) / 2;
            x2 = (k + D) / 2;

            y1 = k - x1;
            y2 = k - x2;
            
            if(x1 >= 0 && y1 >= 0 && min(x1, y1) < min(a, b) && max(x1, y1) < max(a, b)) {
                x = x1;
                y = y1;
                v1 = true;
            }
            else {
                v1 = false;
            }
            if(x2 >= 0 && y2 >= 0 && min(x2, y2) < min(a, b) && max(x2, y2) < max(a, b)) {
                x = x2;
                y = y2;
                v2 = true;
            }
            else {
                v2 = false;
            }

            if (v1 && v2) {
                if (min(x1, y1) < min(x2, y2)) {
                    x = x1;
                    y = y1;
                }
                else {
                    x = x2;
                    y = y2;
                }
            }

            if (!v1 && !v2) {
                x = x1;
                y = y1;
                impossible = true;
            }
        }

        if (a < b || (v1 && v2)) {
            h = min(x, y);
            v = max(x, y);
        }
        else {
            h = max(x, y);
            v = min(x, y);
        }

        if (h >= a || v >= b || h < 0 || v < 0) {
            // cout << x1 << " " << y1 << " " << x2 << " " << y2 << endl;
            impossible = true;
        }

        if (impossible) {
            cout << -1 << endl;
        }
        else {
           cout << h << " " << v << endl;
        }

    }
}

/*
3
2 2 1 2
1 2 2 3
3 5 5 12
*/