#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define ll long long int
#define ull unsigned long long

const int N = 100;
const double eps = 0.0000001;

int main() {
    int n, ans;
    ll p;
    cin >> n >> p;
    int a_old[N], b_old[N], z_old[N], z[N], a[N], b[N], power_out[N];
    vector<int> nums;
    for(int i = 0; i < n; i++) {
        cin >> z_old[i] >> a_old[i] >> b_old[i];
        nums.push_back(i);
    }
    sort(nums.begin(), nums.end(), [z_old](int x, int y) {
        return z_old[x] < z_old[y];
    });

    ll b_sum = 0, a_sum = 0, az_sum = 0, bz_sum;

    for(int i = 0; i < n; i++) {
        a[i] = a_old[nums[i]];
        b[i] = b_old[nums[i]];
        z[i] = z_old[nums[i]];
    }

    ll zans = 0;
    int turned_upto = n;

    for(int i = -1; i < n; i++) {
        int value_i = 0, xi;
        if (i != -1)
            xi = z[i];
        else
            xi = 0;
        
        for(int j = 0; j < n; j++) {
            if (j <= i) { // turned on
                value_i += a[j] * z[j] + b[j] * (xi - z[j]);
            }
            else { // turned off
                value_i += a[j] * xi;
            }
        }

        if (value_i == p) {
            turned_upto = i;
            zans = xi;
            break;
        }
        if (value_i > p) {
            turned_upto = i-1;
            if (i > 0)
                zans = z[i-1];
            else
                zans = 0;
            break;
        }
    }

    if (turned_upto == n)
        zans = z[n-1];

    for(int i = 0; i <= turned_upto; i++) {
        b_sum += b[i];
        az_sum += a[i] * z[i];
        bz_sum += (zans - z[i]) * b[i];
    }

    for(int i = max(0, turned_upto+1); i < n; i++) {
        a_sum += a[i];
    }

    ans = zans + (p - az_sum - bz_sum) / (b_sum + a_sum);
    cout << ans;

    return 0;
}


/*
3 15
2 3 3
4 2 1
5 2 2
*/