#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define ll long long int
#define ull unsigned long long

const int N = 100;
const double eps = 0.0000001;

int main() {
    int n;
    ll p, ans;
    cin >> n >> p;
    ll a_old[N], b_old[N], z_old[N], z[N], a[N], b[N], power_out[N];
    vector<int> nums;
    for(int i = 0; i < n; i++) {
        cin >> z_old[i] >> a_old[i] >> b_old[i];
        nums.push_back(i);
    }
    sort(nums.begin(), nums.end(), [z_old](int x, int y) {
        return z_old[x] < z_old[y];
    });

    ll b_sum = 0, a_sum = 0, az_sum = 0, bz_sum = 0;

    for(int i = 0; i < n; i++) {
        a[i] = a_old[nums[i]];
        b[i] = b_old[nums[i]];
        z[i] = z_old[nums[i]];
    }

    ll zans = 0;
    int turned_upto = n-1;

    for(int i = -1; i < n; i++) {
        int value_i = 0, xi;
        if (i != -1)
            xi = z[i];
        else
            xi = 0;
        
        for(int j = 0; j < n; j++) {
            if (j <= i) { // turned on
                value_i += a[j] * z[j] + b[j] * (xi - z[j]);
            }
            else { // turned off
                value_i += a[j] * xi;
            }
        }

        // cout << xi << " gives " << value_i << endl;

        if (value_i == p) {
            // cout << "stopped at i=" << i << endl;
            turned_upto = i;
            zans = xi;
            break;
        }
        if (value_i > p) {
            // cout << "turned up to at i=" << i-1 << endl;
            turned_upto = i-1;
            if (turned_upto >= 0)
                zans = z[turned_upto];
            else
                zans = 0;
            break;
        }
    }

    if (turned_upto == n-1)
        zans = z[n-1];
    if (turned_upto < 0) {
        turned_upto = -1;
        zans = 0;
    }

    for(int i = 0; i <= turned_upto; i++) {
        if (i >= n) continue;

        b_sum += b[i];
        az_sum += a[i] * z[i];
        bz_sum += (zans - z[i]) * b[i];
    }

    for(int i = turned_upto+1; i < n; i++) {
        if (i < 0) continue;
        a_sum += a[i];
    }

    // cout << turned_upto << endl;
    // cout << a_sum << " " << b_sum << endl;
    // cout << az_sum << " " << bz_sum << endl;
    // cout << zans << endl;

    // cout << endl;

    ans = zans + ((p - az_sum - bz_sum - a_sum * zans) / (b_sum + a_sum));
    if ((p - az_sum - bz_sum - a_sum * zans) % (b_sum + a_sum) != 0)
        ans += 1;
    cout << ans << endl;

    return 0;
}



/*
1 6
4 1 2

3 15
5 2 2
2 3 3
4 2 1

2 30
15 1 1
15 1 1

3 5
28 11 50
4 5 1
6 5 3


1 13
6 2 3

1 100000000000
1 1 1

*/