#include <iostream>
#include <algorithm>
#include <climits>
#include <string>
#include <vector>
#include <math.h>

using namespace std;

#define ll long long int
#define ull unsigned long long

const int N = 10e6+1;
const double eps = 0.0000001;

const int k = 1e9+7;

int main() {
    int n, m, ans;
    cin >> n >> m;
    int a[8];
    for(int i = 0; i < m; i++) {
        cin >> a[i];
    }

    int dp[101];
    dp[0] = 1;
    dp[1] = m;

    for(int i = 2; i <= n; i++) {
        dp[i] = 0;
        for(int j = 0; j < m; j++) {
            int p = a[j];
            if (i - p > 0)
                dp[i] = (dp[i] + dp[i-p]) % k;
            else
                dp[i] = dp[i] + m - 1;
        }
    }
    
    cout << dp[n];
    return 0;
}