#include <iostream>
#include <algorithm>
#include <climits>
#include <string>
#include <vector>
#include <math.h>

using namespace std;

#define ll long long int
#define ull unsigned long long

const int N = 3e3+1;
const double eps = 0.0000001;

int variants[N][N];

int main() {
    int n, ans, q;
    int a[N];
    cin >> n >> q;
    bool up = true;
    for(int i = 0; i < n; i++) {
        cin >> a[i];
        if (i > 0 && a[i] < a[i-1])
            up = false;
    }

    if (!up) {

        for(int start = 0; start < n; start++) {
            variants[start][0] = 1;
            // cout << "starting with " << start << endl;
            int l = start;
            int r = start;
            int curr;
            for(int step = 1; step < n; step++) {
                if (r == n-1 && l == 0) {
                    break;
                }
                else if (r == n-1) {
                    l--;
                    curr = l;
                }
                else if (l == 0) {
                    r++;
                    curr = r;
                }
                else {
                    if (a[l-1] < a[r+1]) {
                        l--;
                        curr = l;
                    }
                    else {
                        r++;
                        curr = r;
                    }
                }

                variants[curr][step]++;
                // cout << step << ") " << curr << endl;
            }
            // cout << endl;
        }
    }

    while(q--) {
        int p, k;
        cin >> p >> k;
        p--; k--;
        if (up) {
            int ans = 0;
            if (p+k <= n) ans++;
            if (k==p) ans++;
            //     cout << 1 << endl;
            
            cout << ans << endl;
        }
        else
            cout << variants[p][k] << endl;
    }
    return 0;
}


/*

6 4
1 4 6 5 2 3
3 1
2 2
6 3
4 3


5 3
5 2 3 4 1
2 3
4 4
3 2

*/